<?php 
/**
 * @package  RenewalReminders
 */

require SPRR_PLUGIN_DIR . 'templates/renewal-reminders-email.php';


class SPRRSendNotifications
{

    function sprr_send_notifications()
    {
       add_action( 'renewal_reminders', array($this, 'sprr_send_subscriber_notification_emaill') );
    }


    /**
     * find subscribers whose reminder date is today.
     */
    public function sprr_send_subscriber_notification_emaill() 
    {  
        global $wpdb;
        $table_name = $wpdb->prefix . 'renewal_reminders';
        $today = new DateTime(); 
        $today = $today->format("Y-m-d");
        // $today = "2021-05-09";
        $options_en = get_option( 'en_disable' );  
        $subscription_details = $wpdb->get_results("SELECT subscription__id FROM $table_name WHERE notification_sent_date = '$today'");
        foreach($subscription_details as $subscription_detail ) {
            $subscription_id = $subscription_detail -> subscription__id;
            $subscription_details = wcs_get_subscription( $subscription_id );
            $user_id = $subscription_details->get_user_id();
            $user = get_user_by( 'id', $user_id );
            if ($user && $options_en=='on') 
            {
                $subscriber_details['name'] = $user->first_name . ' ' . $user->last_name;
                $subscriber_details['email'] = $user->user_email;
                $next_payment_date_dt = $subscription_details->get_date( 'next_payment' );
                $next_payment_date = date( 'Y-m-d', strtotime( $next_payment_date_dt ) );
                $to = $subscriber_details['email'];
                $subject = get_option( 'email_subject' );
                $headers = array('Content-Type: text/html; charset=UTF-8'); 
                $body = sprr_renewalremindersemail($subscriber_details['name'],$next_payment_date);
                wp_mail( $to, $subject, $body, $headers );         
            }
        }                          
    } // end send_subscriber_notification_emaill

}//end class